#!/usr/bin/perl -w

# Perl's unless is an inverse if.  That is, unless(a) is the same as
# if (!(a)).

unless ($ARGV[0]) {
  die "Must specify a directory."
}

# -d is a Perl shorthand.  It does a stat() on the passed filename, and
# then looks at the mode.  If the filename is a directory, it returns true;
# if not, it returns false.

unless (-d $ARGV[0]) {
  die "The filename supplied was not a directory."
}

# This is the same as DIRHANDLE = opendir("filename") in C.
# In C, you can use DIR *DIRHANDLE; to declare the variable.

opendir(DIRHANDLE, $ARGV[0]) or die "Couldn't open directory: $!";

# In C, readdir() returns a pointer to struct dirent, whose members are
# defined in readdir(3).  In Perl, returns one file in scalar context,
# or all remaining filenames in list context.

while ($filename = readdir(DIRHANDLE)) {
  print "$filename\n";
}

closedir(DIRHANDLE);
